# -*- coding: utf-8 -*-
"""Calibrated.

This file is automatically generated. Do not modify!
"""

from micado.dataitems.CatalogableBase import CatalogableBase, persistent
from micado.recipes.McdImgCalibrate import McdImgCalibrate
from micado.dataitems.DetrendFinalSiaiBase import DetrendFinalSiaiBase
from micado.dataitems.PhotomBase import PhotomBase
from micado.dataitems.Astrom import Astrom
from micado.requirements.DPS3160SCI import DPS3160SCI
from micado.dataitems.CalibratedQC import CalibratedQC
from micado.dataitems.CalibratedExtension import CalibratedExtension


class Calibrated(CatalogableBase):
    """Rectified, flux calibrated and background subtracted image."""

    dummy_calibrated = persistent("dummy [][None]", int, 42)

    det_dit = persistent(
        "Detector integration time (average when NDIT > 1) [DET DIT][s]", float, 1.0
    )

    filtname = persistent("Filter name [INS FILT NAME][None]", str, "")

    mjdobs = persistent(
        "Modified Julian Day of the start of the exposure. The MJD is related "
        "to the Julian Day (JD) via the formula: MJD = JD-2400000.5 The comment"
        " includes a civil representation of the date and time. 8 decimals are "
        "required for a precision of one millisecond, 5 decimals for a "
        "precision of one second. [MJD-OBS][]",
        float,
        0.0,
    )

    tpl__start = persistent("Start time of template [TPL START][None]", float, 0.0)

    ra = persistent("Right Ascension [OBS RA][deg]", float, 0.0)

    dec = persistent("Declination [OBS DEC][deg]", float, 0.0)

    recipe = persistent("The recipe [][None]", McdImgCalibrate, None)

    detrend = persistent("Fully detrended image [][None]", DetrendFinalSiaiBase, None)

    photom = persistent("Photometric solution [][None]", PhotomBase, None)

    astrom = persistent("Astrometric solution [][None]", Astrom, None)

    requirement = persistent("None [][None]", DPS3160SCI, None)

    qc = persistent("Quality Control parameters [][None]", CalibratedQC, None)

    extensions = persistent("CalibratedExtensions [][None]", CalibratedExtension, [])
