"""Module with persistent Tab classes."""

from typing import List, Tuple, Optional

from micado.main.DataItem import DataItem
from micado.main.DataItemExtra import KEY_TAB


class TabExtra(DataItem):
    """A Tab DataItem."""

    @classmethod
    def layer_names(cls) -> Tuple[List[str], List[str]]:
        """The names of the layers of this data product."""
        return [KEY_TAB], []

    @classmethod
    def layers_number(cls) -> Tuple[Optional[int], Optional[int]]:
        """Minimum/maximum number of detectors for each layer."""
        # TODO: Move these to AstromExtra and IllumCorrExtra?
        from micado.dataitems.IllumCorr import IllumCorr
        from micado.dataitems.Astrom import Astrom
        from micado.dataitems.PhotomBase import PhotomBase

        if issubclass(cls, (Astrom, IllumCorr, PhotomBase)):
            return 9, 9
        else:
            return 1, 1
